/**
 * @cond doxygenLibsbmlInternal
 *
 * @file    InternalConsistencyConstraintsDeclared.cxx
 * @brief   Declarations of constraints
 * @author  SBML Team
 * 
 * <!--------------------------------------------------------------------------
 * This file is part of libSBML.  Please visit http://sbml.org for more
 * information about SBML, and the latest version of libSBML.
 *
 * Copyright (C) 2019 jointly by the following organizations:
 *     1. California Institute of Technology, Pasadena, CA, USA
 *     2. University of Heidelberg, Heidelberg, Germany
 *
 * Copyright (C) 2013-2018 jointly by the following organizations:
 *     1. California Institute of Technology, Pasadena, CA, USA
 *     2. EMBL European Bioinformatics Institute (EMBL-EBI), Hinxton, UK
 *     3. University of Heidelberg, Heidelberg, Germany
 *
 * Copyright (C) 2009-2013 jointly by the following organizations: 
 *     1. California Institute of Technology, Pasadena, CA, USA
 *     2. EMBL European Bioinformatics Institute (EMBL-EBI), Hinxton, UK
 *  
 * Copyright (C) 2006-2008 by the California Institute of Technology,
 *     Pasadena, CA, USA 
 *  
 * Copyright (C) 2002-2005 jointly by the following organizations:
 *     1. California Institute of Technology, Pasadena, CA, USA
 *     2. Japan Science and Technology Agency, Japan
 * 
 * This library is free software; you can redistribute it and/or modify it
 * under the terms of the GNU Lesser General Public License as published by
 * the Free Software Foundation.  A copy of the license agreement is provided
 * in the file named "LICENSE.txt" included with this software distribution
 * and also available online as http://sbml.org/software/libsbml/license.html
 * ---------------------------------------------------------------------- -->*/

addConstraint(new VConstraintCompartment99901(*this));

addConstraint(new VConstraintCompartment99902(*this));

addConstraint(new VConstraintCompartment99903(*this));

addConstraint(new VConstraintParameter99903(*this));

addConstraint(new VConstraintCompartment99904(*this));

addConstraint(new VConstraintKineticLaw99904(*this));

addConstraint(new VConstraintModel99904(*this));

addConstraint(new VConstraintParameter99904(*this));

addConstraint(new VConstraintReaction99904(*this));

addConstraint(new VConstraintAssignmentRule99904(*this));

addConstraint(new VConstraintRateRule99904(*this));

addConstraint(new VConstraintAlgebraicRule99904(*this));

addConstraint(new VConstraintSpecies99904(*this));

addConstraint(new VConstraintSpeciesReference99904(*this));

addConstraint(new VConstraintUnit99904(*this));

addConstraint(new VConstraintUnitDefinition99904(*this));

addConstraint(new VConstraintCompartment99905(*this));

addConstraint(new VConstraintCompartmentType99905(*this));

addConstraint(new VConstraintDelay99905(*this));

addConstraint(new VConstraintSpecies99905(*this));

addConstraint(new VConstraintSpeciesType99905(*this));

addConstraint(new VConstraintSpeciesReference99905(*this));

addConstraint(new VConstraintTrigger99905(*this));

addConstraint(new VConstraintUnit99905(*this));

addConstraint(new VConstraintUnitDefinition99905(*this));

addConstraint(new VConstraintCompartment99906(*this));

addConstraint(new VConstraintCompartment99907(*this));

addConstraint(new VConstraintModel99908(*this));

addConstraint(new VConstraintModel99909(*this));

addConstraint(new VConstraintModel99910(*this));

addConstraint(new VConstraintEvent99911(*this));

addConstraint(new VConstraintEventAssignment99911(*this));

addConstraint(new VConstraintFunctionDefinition99911(*this));

addConstraint(new VConstraintKineticLaw99911(*this));

addConstraint(new VConstraintModel99911(*this));

addConstraint(new VConstraintParameter99911(*this));

addConstraint(new VConstraintReaction99911(*this));

addConstraint(new VConstraintAssignmentRule99911(*this));

addConstraint(new VConstraintRateRule99911(*this));

addConstraint(new VConstraintAlgebraicRule99911(*this));

addConstraint(new VConstraintSpeciesReference99911(*this));

addConstraint(new VConstraintModel99912(*this));

addConstraint(new VConstraintModel99913(*this));

addConstraint(new VConstraintAlgebraicRule99914(*this));

addConstraint(new VConstraintAssignmentRule99915(*this));

addConstraint(new VConstraintRateRule99915(*this));

addConstraint(new VConstraintAlgebraicRule99915(*this));

addConstraint(new VConstraintSpecies99916(*this));

addConstraint(new VConstraintSpeciesReference99916(*this));

addConstraint(new VConstraintSpecies99917(*this));

addConstraint(new VConstraintSpecies99918(*this));

addConstraint(new VConstraintSpecies99919(*this));

addConstraint(new VConstraintSpeciesReference99920(*this));

addConstraint(new VConstraintSpeciesReference99921(*this));

addConstraint(new VConstraintModel99922(*this));

addConstraint(new VConstraintSpeciesReference99923(*this));

addConstraint(new VConstraintUnit99924(*this));

addConstraint(new VConstraintUnit99925(*this));

addConstraint(new VConstraintFunctionDefinition20306(*this));

addConstraint(new VConstraintInitialAssignment20804(*this));

addConstraint(new VConstraintAssignmentRule20907(*this));

addConstraint(new VConstraintRateRule20907(*this));

addConstraint(new VConstraintAlgebraicRule20907(*this));

addConstraint(new VConstraintConstraint21007(*this));

addConstraint(new VConstraintReaction21101(*this));

addConstraint(new VConstraintKineticLaw21130(*this));

addConstraint(new VConstraintReaction21152(*this));
 
addConstraint(new VConstraintEvent21201(*this));

addConstraint(new VConstraintEvent21203(*this));

addConstraint(new VConstraintTrigger21209(*this));

addConstraint(new VConstraintDelay21210(*this));

addConstraint(new VConstraintEventAssignment21213(*this));

addConstraint(new VConstraintPriority21231(*this));
/** @endcond */

