/**
 * @cond doxygenLibsbmlInternal
 *
 * @file    SBOConsistencyConstraintsDeclared.cxx
 * @brief   Declarations of constraints
 * @author  SBML Team
 * 
 * <!--------------------------------------------------------------------------
 * This file is part of libSBML.  Please visit http://sbml.org for more
 * information about SBML, and the latest version of libSBML.
 *
 * Copyright (C) 2019 jointly by the following organizations:
 *     1. California Institute of Technology, Pasadena, CA, USA
 *     2. University of Heidelberg, Heidelberg, Germany
 *
 * Copyright (C) 2013-2018 jointly by the following organizations:
 *     1. California Institute of Technology, Pasadena, CA, USA
 *     2. EMBL European Bioinformatics Institute (EMBL-EBI), Hinxton, UK
 *     3. University of Heidelberg, Heidelberg, Germany
 *
 * Copyright (C) 2009-2013 jointly by the following organizations: 
 *     1. California Institute of Technology, Pasadena, CA, USA
 *     2. EMBL European Bioinformatics Institute (EMBL-EBI), Hinxton, UK
 *  
 * Copyright (C) 2006-2008 by the California Institute of Technology,
 *     Pasadena, CA, USA 
 *  
 * Copyright (C) 2002-2005 jointly by the following organizations:
 *     1. California Institute of Technology, Pasadena, CA, USA
 *     2. Japan Science and Technology Agency, Japan
 * 
 * This library is free software; you can redistribute it and/or modify it
 * under the terms of the GNU Lesser General Public License as published by
 * the Free Software Foundation.  A copy of the license agreement is provided
 * in the file named "LICENSE.txt" included with this software distribution
 * and also available online as http://sbml.org/software/libsbml/license.html
 * ---------------------------------------------------------------------- -->*/

addConstraint(new VConstraintModel99701(*this));

addConstraint(new VConstraintFunctionDefinition99701(*this));

addConstraint(new VConstraintParameter99701(*this));

addConstraint(new VConstraintInitialAssignment99701(*this));

addConstraint(new VConstraintAssignmentRule99701(*this));

addConstraint(new VConstraintRateRule99701(*this));

addConstraint(new VConstraintAlgebraicRule99701(*this));

addConstraint(new VConstraintConstraint99701(*this));

addConstraint(new VConstraintReaction99701(*this));

addConstraint(new VConstraintSpeciesReference99701(*this));

addConstraint(new VConstraintKineticLaw99701(*this));

addConstraint(new VConstraintEvent99701(*this));

addConstraint(new VConstraintEventAssignment99701(*this));

addConstraint(new VConstraintCompartment99701(*this));

addConstraint(new VConstraintSpecies99701(*this));

addConstraint(new VConstraintCompartmentType99701(*this));

addConstraint(new VConstraintSpeciesType99701(*this));

addConstraint(new VConstraintTrigger99701(*this));

addConstraint(new VConstraintDelay99701(*this));

addConstraint(new VConstraintModel10701(*this));

addConstraint(new VConstraintFunctionDefinition10702(*this));

addConstraint(new VConstraintParameter10703(*this));

addConstraint(new VConstraintInitialAssignment10704(*this));

addConstraint(new VConstraintAssignmentRule10705(*this));

addConstraint(new VConstraintRateRule10705(*this));

addConstraint(new VConstraintAlgebraicRule10705(*this));

addConstraint(new VConstraintConstraint10706(*this));

addConstraint(new VConstraintReaction10707(*this));

addConstraint(new VConstraintSpeciesReference10708(*this));

addConstraint(new VConstraintKineticLaw10709(*this));

addConstraint(new VConstraintEvent10710(*this));

addConstraint(new VConstraintEventAssignment10711(*this));

addConstraint(new VConstraintCompartment10712(*this));

addConstraint(new VConstraintSpecies10713(*this));

addConstraint(new VConstraintCompartmentType10714(*this));

addConstraint(new VConstraintSpeciesType10715(*this));

addConstraint(new VConstraintTrigger10716(*this));

addConstraint(new VConstraintDelay10717(*this));

addConstraint(new VConstraintLocalParameter10718(*this));

addConstraint(new VConstraintModel99702(*this));

addConstraint(new VConstraintFunctionDefinition99702(*this));

addConstraint(new VConstraintParameter99702(*this));

addConstraint(new VConstraintInitialAssignment99702(*this));

addConstraint(new VConstraintAssignmentRule99702(*this));

addConstraint(new VConstraintRateRule99702(*this));

addConstraint(new VConstraintAlgebraicRule99702(*this));

addConstraint(new VConstraintConstraint99702(*this));

addConstraint(new VConstraintReaction99702(*this));

addConstraint(new VConstraintSpeciesReference99702(*this));

addConstraint(new VConstraintKineticLaw99702(*this));

addConstraint(new VConstraintEvent99702(*this));

addConstraint(new VConstraintEventAssignment99702(*this));

addConstraint(new VConstraintCompartment99702(*this));

addConstraint(new VConstraintSpecies99702(*this));

addConstraint(new VConstraintCompartmentType99702(*this));

addConstraint(new VConstraintSpeciesType99702(*this));

addConstraint(new VConstraintTrigger99702(*this));

addConstraint(new VConstraintDelay99702(*this));
/** @endcond */

